



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JS魔法堂：再识IE的内存泄露</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JS魔法堂：再识IE的内存泄露</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 14:33:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、前言　　　　　　　　　　　　　　　　　　　　　　　　　　　　</strong></p>
<p>IE6~8除了不遵守W3C标准和各种诡异外，我想最让人诟病的应该是内存泄露的问题了。这阵子趁项目技术调研的机会好好的再认识一回，以下内容若有纰漏请大家指正，谢谢！</p>
<p>目录一大坨！</p>
<p><a href="#a2" rel="external nofollow noreferrer">二、内存泄漏到底是哪里漏了？</a></p>
<p><a href="#a21" rel="external nofollow noreferrer">2.1. JS Engine Object、DOM Element 和 BOM Element</a></p>
<p><a href="#a22" rel="external nofollow noreferrer">2.2. JS Engine Object的内存回收机制</a></p>
<p><a href="#a23" rel="external nofollow noreferrer">2.3. DOM Element的内存回收机制</a></p>
<p><a href="#a24" rel="external nofollow noreferrer">2.4. 两种泄漏方式</a></p>
<p><a href="#a3" rel="external nofollow noreferrer">三、4种泄漏模式</a></p>
<p>　　 &nbsp;<a href="#a31" rel="external nofollow noreferrer">3.1.&nbsp;Circular References</a></p>
<p>　　 &nbsp;<a href="#a32" rel="external nofollow noreferrer">3.2. Closures</a></p>
<p>　　 &nbsp;<a href="#a33" rel="external nofollow noreferrer">3.3. Cross-page Leaks</a></p>
<p><a href="#a34" rel="external nofollow noreferrer">3.4. Pseduo-Leaks</a></p>
<p><a href="#a4" rel="external nofollow noreferrer">四、当前页面泄漏的示例</a></p>
<p><a href="#a41" rel="external nofollow noreferrer">4.1.&nbsp;DOM Hyperspace引起的DOM Element引用孤岛</a></p>
<p>　 &nbsp; &nbsp; &nbsp;<a href="#a42" rel="external nofollow noreferrer">4.2.&nbsp;释放Iframe没那么简单</a></p>
<p><a href="#a5" rel="external nofollow noreferrer">五、IE8下连续修改IMG的src居然耗尽内存？</a></p>
<p><a href="#a6" rel="external nofollow noreferrer">六、监控工具</a></p>
<p><a href="#a7" rel="external nofollow noreferrer">七、总结</a></p>
<p><a href="#a8" rel="external nofollow noreferrer">八、参考</a></p>
<p><strong>二、内存泄漏到底是哪里漏了？</strong>　　　　　　　　　　　　　　　　　　</p>
<p>SPA跑久了页面响应速度剧减又被用户投诉，搪塞说句&ldquo;IE是比较容易发生内存泄漏，刷刷页面就好&rdquo;。那真的是刷刷页面就能释放泄漏了的内存吗？下面我们一起来探讨一下！</p>
<p><strong>&nbsp; 内存泄漏：内存资源得不到释放 &amp;&amp; 失去对该内存区的指针 =&gt; 无法复用内存资源，最终导致内存溢出</strong></p>
<p><strong>2.1. JS Engine Object、DOM Element 和 BOM Element</strong></p>
<p>Script中我们能操作的对象可分为三种：JS Engine Object、DOM Element 和 BOM Element。</p>
<p><strong><em>JS Engine Object：</em></strong>&nbsp;var obj = Object(); var array = [];等等</p>
<p>　 &nbsp; &nbsp;<em><strong>DOM Element：</strong></em>&nbsp;var el = document.createElement('div'); var div = document.getElementById('name');等等</p>
<p>　　 <em><strong>BOM Element：</strong></em>&nbsp;window; window.location;等等</p>
<p>其中只有JS Engine Object和DOM Element是我们可以CRUD的，因此也就有可能发生内存泄漏的问题。</p>
<p><strong>&nbsp; 2.2. JS Engine Object的内存回收机制</strong>　</p>
<p>IE的JScript Garbage Collector采用的是Mark-and-Sweep算法，当执行垃圾回收时会先遍历所有JS Engine Object并标记未被引用的对象，然后释放掉被标记的内存空间。</p>
<p>由于Mark-and-Sweep算法的缘故，也能很好地释放引用孤岛的内存空间。</p>
<p>而IE下独有的CollectGarbage()则用于回收无引用或引用孤岛的JS Engine Object。</p>
<p><strong>&nbsp; 2.3. DOM Element的内存回收机制</strong></p>
<p>当DOM Element不再被引用时会被回收，但具体被谁何时回收则有待研究了。</p>
<p><strong>&nbsp; 2.4. 两种泄漏方式</strong></p>
<p>a. 当前页面泄漏：刷新页面或跳转到其他页面就能释放的内存资源。</p>
<p>b. 跨页面泄漏：刷新页面或跳转到其他页面也无法释放的内存资源。</p>
<p>当前页面泄漏处理难度相对简单，跨页面泄漏才是处理大头。</p>
<p><strong>三、4种泄漏模式　　　　　　　　　　　　　　　　　　　　　　 &nbsp;<br /></strong></p>
<p>下面是Justin Rogers总结出来的4种会引起泄漏的反模式。</p>
<p><strong>&nbsp; 3.1.&nbsp;Circular References(导致跨页面内存泄漏)</strong></p>
<p>循环引用可谓是引起内存泄漏的根本原因，其他的泄漏模式最底层还是因为出现的循环引用。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/347002/201504/251722093128388.gif" /></p>
<p><em><strong>Leak Memory</strong></em></p>
<div>
<pre class="prettyprint linenums">&lt;div id="test"&gt;&lt;/div&gt;<br />
&lt;script type="text/javascript"&gt;<br />
  var $el = {tag: 'div', dom: null} // 创建JS Engine Object<br />
  $el.dom = document.getElementById('test') // JS Engine Object references to DOM Element<br />
  $el.dom.expandoProp = $el // DOM Element references to JS Engine Object

  // 造成circular references<br />
  // GC不会清理$el，而页面刷新时也不会清理$el.dom

  setTimeout('location.reload()', ) // 刷新页面<br />
&lt;/script&gt;</pre>
</div>
<p><em><strong>Non-Leak Memory</strong></em></p>
<div>
<pre class="prettyprint linenums">&lt;body onunload="clearMemory()"&gt;<br />
    &lt;div id="test"&gt;&lt;/div&gt;<br />
    &lt;script type="text/javascript"&gt;<br />
      function clearMemory(){<br />
        $el.dom.expandoProp = null; // 解除DOM Element references to JS Engine Object，那么页面刷新时就会清除$el.dom，而$el也会被GC清除<br />
      }

      var $el = {tag: 'div', dom: null} // 创建JS Engine Object<br />
      $el.dom = document.getElementById('test') // JS Engine Object references to DOM Element<br />
      $el.dom.expandoProp = $el // DOM Element references to JS Engine Object

      // 造成circular references<br />
      // GC不会清理$el，而页面刷新时也不会清理$el.dom

      setTimeout('location.reload()', ) // 刷新页面<br />
    &lt;/script&gt;<br />
&lt;/body&gt;</pre>
</div>
<p><strong>&nbsp; 3.2. Closures<strong>(导致跨页面内存泄漏)</strong></strong></p>
<p>闭包具有Lexical scope特性，延长了方法参数和局部变量的生命周期，但同时又容易在无意当中引入循环引用的问题。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/347002/201504/251738070003477.gif" /></p>
<p><em><strong>Leak Memory</strong></em></p>
<div>
<pre class="prettyprint linenums">&lt;div id="test"&gt;&lt;/div&gt;<br />
&lt;script type="text/javascript"&gt;<br />
  ;(function (){<br />
    var $el = {tag: 'div', dom: null}<br />
    $el.dom = document.getElementById('test') // JS Engine Object references to DOM Element<br />
    $el.dom.attachEvent('click', onclick) // DOM Element references to JS Engine Object<br />
    // 此时还没形成circular references

    function onclick(){} // onclick的方法体内隐式引用$el及$el内的dom属性，因此形成了circular refereneces<br />
    // function onclick(){ return eval('$el &amp;&amp; true || false') } 返回true<br />
  }())<br />
&lt;/script&gt;</pre>
</div>
<p><em><strong>Non-Leak Memory</strong></em></p>
<div>
<pre class="prettyprint linenums">&lt;div id="test"&gt;&lt;/div&gt;<br />
&lt;script type="text/javascript"&gt;<br />
  ;(function (){<br />
    var $el = {tag: 'div', dom: null}<br />
    $el.dom = document.getElementById('test') // JS Engine Object references to DOM Element<br />
    $el.dom.attachEvent('click', onclick) // DOM Element references to JS Engine Object<br />
    // 此时还没形成circular references<br />
  }())<br />
  function onclick(){}  // onclick方法体内没有引用$el<br />
&lt;/script&gt;</pre>
</div>
<p><strong>&nbsp; 3.3. Cross-page Leaks（当前页面内存泄漏）</strong></p>
<p>由于节点建立联系时会寻找scope，若没有则创建temporary scope，若有则抛弃原有的temporary scope采用已有的scope。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/347002/201504/251809441719580.gif" /></p>
<p><strong>Leak Memory</strong></p>
<div>
<pre class="prettyprint linenums">&lt;html&gt;<br />
     &lt;head&gt;<br />
         &lt;script language="JScript"&gt;<br />
         function  LeakMemory()<br />
        {<br />
             var  hostElement  =  document.getElementById("hostElement"); //  Do it a lot, look at Task Manager for memory response

             for (i  =    ; i  &lt;  ; i ++ )<br />
            {<br />
                 var  parentDiv  =<br />
                    document.createElement("&lt;div onClick='foo()'&gt;");<br />
                 var  childDiv  =<br />
                    document.createElement("&lt;div onClick='foo()'&gt;"); //  This will leak a temporary object<br />
                parentDiv.appendChild(childDiv);<br />
                hostElement.appendChild(parentDiv);<br />
                hostElement.removeChild(parentDiv);<br />
                parentDiv.removeChild(childDiv);<br />
                parentDiv  =   null ;<br />
                childDiv  =   null ;<br />
            }<br />
            hostElement  =   null ;<br />
        }<br />
     &lt;/script&gt;<br />
     &lt;/head&gt;<br />
     &lt;body&gt;<br />
         &lt;button onclick ="LeakMemory()"&gt; Memory Leaking Insert &lt;/button&gt;<br />
         &lt;div id ="hostElement"&gt;&lt;/div&gt;<br />
     &lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>当childDiv与parentDiv建立连接时，为让childDiv能获取parentDiv的信息，IE会创建temporary scope。而当将parentDiv添加到DOM tree中时，则childDiv和parentDiv均继承document的scope，而temporary scope却不会被GC释放，而要等待浏览器刷新页面才能清理。</p>
<p><strong>Non-Leak Memory</strong></p>
<div>
<pre class="prettyprint linenums">&lt;html&gt;<br />
     &lt;head&gt;<br />
         &lt;script language="JScript"&gt;<br />
       function  CleanMemory()<br />
        {<br />
             var  hostElement  =  document.getElementById("hostElement"); //  Do it a lot, look at Task Manager for memory response

             for (i  =    ; i  &lt;  ; i ++ )<br />
            {<br />
                 var  parentDiv  =   document.createElement("&lt;div onClick='foo()'&gt;");<br />
                 var  childDiv  =   document.createElement("&lt;div onClick='foo()'&gt;"); //  Changing the order is important, this won&rsquo;t leak<br />
                hostElement.appendChild(parentDiv);<br />
                parentDiv.appendChild(childDiv);<br />
                hostElement.removeChild(parentDiv);<br />
                parentDiv.removeChild(childDiv);<br />
                parentDiv  =   null ;<br />
                childDiv  =   null ;<br />
            }<br />
            hostElement  =   null ;<br />
        }<br />
     &lt;/script&gt;<br />
     &lt;/head&gt;<br />
     &lt;body&gt;<br />
         &lt;button onclick ="CleanMemory()"&gt; Clean Insert &lt;/button&gt;<br />
         &lt;div id ="hostElement"&gt;&lt;/div&gt;<br />
     &lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>一直使用document scope，不会创建temporary scope</p>
<p><strong>&nbsp; 3.4. Pseduo-Leaks</strong></p>
<p>连续创建多个JS Engine Object，而GC未能及时释放内存，其实根本就不是内存泄漏</p>
<div>
<pre class="prettyprint linenums">var tmpStr<br />
for(var i = ; i &lt; ; ++i)<br />
  tmpStr = "test"</pre>
</div>
<p><strong>四、当前页面泄漏的示例　　　　　　　　　　　　　　　　　　　　　　</strong></p>
<p><strong>&nbsp; 4.1.&nbsp;DOM Hyperspace引起的DOM Element引用孤岛</strong></p>
<p>DOM Hyperspace由PPK发现，在IE下通过removeChild或removeNode从父节点（无论是否已加入DOM Tree）中移除节点后，会创建一个新的#documentFragment，并且被移除的节点的parentNode为该#documentFragment，而该#documentFragment.firstChild为被移除的节点，因此存在DOM Element间的circular reference导致无法释放，只有刷新页面后才会释放资源。</p>
<p><em><strong>Leak Memory</strong></em></p>
<div>
<pre class="prettyprint linenums">var div = document.createElement('div')<br />
document.body.appendChild(div)<br />
div.parentNode.removeChild(div)

alert(div.parentNode) // IE8下为[Object object]，Chrome等浏览器为null</pre>
</div>
<p><em><strong>Non-Leak Memory</strong></em></p>
<div>
<pre class="prettyprint linenums">function rm(el){<br />
  if (!+'\v1'){<br />
    var d = document.createElement('div')<br />
    d.appendChild(el)<br />
    d.innerHTML = ''<br />
  }<br />
  else{<br />
    el.parentNode.removeChild(el)<br />
  }<br />
}

var div = document.createElement('div')<br />
document.body.appendChild(div)<br />
rm(div)

alert(div.parentNode) // IE8下为null</pre>
</div>
<p><strong>&nbsp; 4.2.&nbsp;释放Iframe没那么简单</strong></p>
<p>iframe所占的资源有两部分：iframe元素所占的内存空间 和&nbsp;iframe内页面所占的内存空间。</p>
<p><em><strong>&nbsp; &nbsp; 内存空间释放步骤：</strong></em></p>
<p>　　　　1. 释放&nbsp;iframe内页面所占的内存空间</p>
<p>　　　　　　通过设置src=''或src='about:blank'来释放内部页面的资源</p>
<p>　　　　2. 释放&nbsp;iframe元素所占的内存空间</p>
<p>　　　　　　通过removeChild、removeNode等方法释放iframe元素的内存空间</p>
<p>　<em><strong>　&nbsp;ligerTab1.2.1的清除方式</strong></em></p>
<div>
<pre class="prettyprint linenums">var iframe = ...<br />
iframe.src = 'about:blank'<br />
iframe.contentWindow.document.write('')<br />
CollectGarbage &amp;&amp; CollectGarbage()<br />
iframe.parentNode.removeChild(iframe)</pre>
</div>
<p><strong>五、IE8下连续修改IMG的src居然耗尽内存？　　　　　　　　　　　　</strong></p>
<p>由于IE8会对非原始尺寸的图片进行抗锯齿平滑处理，从而消耗更多的CPU和内存资源。当图片大小和尺寸到一定时，则会出现挂死的情况。（IE6、7没有抗锯齿平滑处理，而IE9则移除该功能）</p>
<p>而这种情况当然就不属于Memory Leak啦！</p>
<blockquote><p><strong><em>&nbsp; 题外话：</em></strong></p>
<p>众所周知IMG是replaced element，其width和height属性缺省值又外部资源决定，而我们通过CSS设置的width和height属性均是对缺省值的二次加工。</p>
<p>假设图片原始尺寸为width:200px/height:400px，现在通过CSS设置width:100px，那么图片将按等比例缩放为width:100px/height:200px；但通过CSS设置width:100px/height:100px时，那么图片则不是按等比例缩放了。</p></blockquote>
<p><strong>六、监控工具　　　　　　　　　　　　　　　　　　　　　　　　　　　&nbsp;</strong></p>
<p>监控方式多种多样，这里大概分为两类：</p>
<p>1.&nbsp;当前页面泄漏：Windows的任务管理器、Chrome-&gt;dev tools-&gt;Profiles-&gt;Take Heap Snapshot/Record Heap Allocations等等</p>
<p>2. 跨页面泄漏：sIEve</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/347002/201504/270852203808396.png" /></p>
<p>操作步骤：</p>
<p>1. 在Address输入框输入网址，点击Go （浏览网页）</p>
<p>2. 执行测试用例</p>
<p>3. 点击about:blank按钮（跳转到空白页）</p>
<p>4. 查看#leaks列下是否有增长，有则表示出现跨页面的内存泄漏</p>
<p><strong>七、总结　　　　　　　　　　　　　　　　　　　　　　　　　　　　&nbsp;<br /></strong></p>
<p>稍微小结一下：</p>
<p>1. 单纯的JS Engine Object的Circular References、Closures是不会引起内存泄漏；</p>
<p>2. 单纯的DOM Element的Circular References只会引起当前页面的内存泄漏；</p>
<p>3. JS Engine Object 和 DOM Element的Circular References、Closures会引起跨页面的内存泄漏；</p>
<p>4. 将DOM Element直接追加到DOM Tree中，可减少temporary scope的创建和丢弃；</p>
<p>5. CollectGarbage()不是万金油。</p>
<p>上述内容以概念为主，最终还是要实战来验证和完善、补充。</p>
<p>尊重原创，转载请注明来自：^_^肥子John&nbsp;<a href="http://www.cnblogs.com/fsjohnhuang/p/4455822.html" rel="external nofollow noreferrer">http://www.cnblogs.com/fsjohnhuang/p/4455822.html</a></p>
<p><strong>八、参考　　　　　　　　　　　　　　　　　　　　　　　　　　　　&nbsp;</strong></p>
<p><a href="http://blogs.msdn.com/b/ericlippert/archive/2003/09/17/53028.aspx" rel="external nofollow noreferrer">What are closures?</a></p>
<p><a href="https://msdn.microsoft.com/en-us/library/bb250448.aspx" rel="external nofollow noreferrer">Understanding and Solving Internet Explorer Leak Patterns</a></p>
<p><a href="http://www.javascriptkit.com/javatutors/closuresleak/index.shtml" rel="external nofollow noreferrer">JavaScript and memory leaks</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2wwy3q.html">AndroidStudio安装流程      以及       使用过程中出现的异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e51we8.html">PHP 水印设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx61yzq.html">Java程序员的日常 &mdash;&mdash; 多进程开发IO阻塞问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4r4de8.html">不支持一个 STA 线程上针对多个句柄的 WaitAll</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o37r39.html">如何给WordPress安装百度统计代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vdwwn8.html">NBUT 1121 Sakuya&amp;&num;39&semi;s Fly Knife 飞刀（暴力）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k15ypr9.html">主机win10与虚拟机ubuntu14&period;04通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1k26x8.html">STUN&sol;TURN&sol;ICE协议在P2P SIP中的应用（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y51kjq.html">Microsoft Visual Studio 2010 遇到了异常&comma;可能是由某个扩展导致的。  转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xe2gv8.html">Java实现断点下载Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gejylz8.html">&lbrack;转&rsqb; Building xnu for OS X 10&period;10 Yosemite</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mel050q.html">Chrome 插件集锦</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yvezg8.html">JavaScript事件（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zopxdvq.html">webgoat&mdash;&mdash;XSS</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojr40lq.html">POJ-2299 Ultra-QuickSort---树状数组求逆序对&plus;离散化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7d679.html">C&num; 使用CsvHelper读取&period;csv文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojx555q.html">andorid简易定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllexg1q.html">C&num; 结构与类的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2vxpoq.html">&lbrack;转&rsqb;OpenBLAS项目与矩阵乘法优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rej608.html">2018&period;11&period;24 loj&num;111&period; 后缀排序（后缀数组）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q72vgg9.html">springrain 1&period;1 发布，spring 的极简封装</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z6p7nq.html">树莓派&lpar;Raspberry Pi&rpar;搭建简单的lamp服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/39045go8.html">【腾讯Bugly干货分享】React移动web极致优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwnmvkq.html">分享一个简单程序&lpar;webApi&plus;castle&plus;Automapper&plus;Ef&plus;angular&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2glex8.html">浏览器兼容性小记-DOM篇（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1y7j2q.html">win10最新预览版9926使用评估</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96lx0y9.html">try catch 与 throw拾遗</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwn6v3q.html">04- Shell脚本学习--条件控制和循环语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw4k038.html">每天一个linux命令（36）：diff 命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kr1o6q.html">使用XSD校验Mybatis的SqlMapper配置文件&lpar;1&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
